import Flutter
import UIKit
import SwifterSwift

public class SwiftSmtFaceMlKitPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
      let channel = FlutterMethodChannel(name: SwiftSmtFaceMlKitPlugin.getPluginName(), binaryMessenger: registrar.messenger())
    let instance = SwiftSmtFaceMlKitPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
//    result("iOS " + UIDevice.current.systemVersion)
      self.__handle(call, result: result)
  }
    
    var currentCameraManager: CameraDetectManager?
}

extension SwiftSmtFaceMlKitPlugin {
    func __handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch call.method {
        case "startFaceMlKit":
            /// 开始检测
//            self.getChannel()?.invokeMethod("msg", arguments: "开始识别")
            let m = CameraDetectManager()
            m.delegate = self
            m.startDetect()
            self.currentCameraManager = m
            break
        case "endFaceMlKit":
            /// 结束检测
            self.currentCameraManager?.stopDetect()
            self.currentCameraManager = nil
//            self.getChannel()?.invokeMethod("msg", arguments: "结束识别")
            break
        
        default:
           
            break
        }
    }
    
    class func getPluginName() -> String {
        return "smt_face_ml_kit"
    }
    
    func getChannel() -> FlutterMethodChannel? {
        if let vc = currentViewController() as? FlutterViewController {
            let channel = FlutterMethodChannel.init(name: SwiftSmtFaceMlKitPlugin.getPluginName(), binaryMessenger: vc.binaryMessenger)
            return channel
        }
        return nil
    }
}


extension SwiftSmtFaceMlKitPlugin: CameraDetectDelegate {
    
    func didDetectFaceImage(_ images: [(OriginSize, UIImage)]) {
        let listJsonStr = images.map({["centerX": $0.0.center.x,
                     "centerY": $0.0.center.y,
                     "width": $0.0.faceSize.width,
                     "height": $0.0.faceSize.height,
                     "imageWidth": $0.0.imgSize.width,
                     "imageHeight": $0.0.imgSize.height].jsonString()})
        self.getChannel()?.invokeMethod("faceInfos", arguments: listJsonStr)
    }
    
    func didOutputImage(_ image: UIImage) {
        
    }
    
    func didDetectLight(_ value: Double) {
        self.getChannel()?.invokeMethod("lightInfo", arguments: [value])
    }
    
    func didFailed(_ msg: String) {
        self.getChannel()?.invokeMethod("error", arguments: msg)
    }
}
